// Generated by CoffeeScript 1.3.3
var anyDB, dialects, fakeEngine, queries, url;

url = require('url');

anyDB = require('any-db');

queries = require('./queries');

dialects = require('./dialects');

module.exports = function(dbUrl, poolOptions) {
  var ctor, dialect, driverName, pool;
  driverName = url.parse(dbUrl).protocol.replace(':', '').split('+').shift();
  if (driverName === 'fake') {
    return fakeEngine();
  }
  ctor = dialects[driverName];
  if (!(ctor != null)) {
    console.error('no such driver', driverName);
  }
  dialect = new ctor;
  pool = anyDB.createPool(dbUrl, poolOptions);
  return queries.mixinFactoryMethods({
    driver: driverName,
    url: dbUrl,
    render: dialect.render.bind(dialect),
    query: pool.query.bind(pool),
    close: pool.close.bind(pool),
    begin: function(cb) {
      var tx;
      tx = queries.mixinFactoryMethods(pool.begin(cb));
      tx.engine = this;
      tx.render = this.render;
      return tx;
    }
  });
};

fakeEngine = function() {
  /*
    Create a no-op engine that simply returns the compiled SQL and parameter
    array to the result callback. This will be the default until you over-ride
    with ``gesundheit.defaultEngine = myAppEngine``.
  */

  var dialect, engine;
  dialect = new dialects.BaseDialect;
  engine = {
    render: dialect.render.bind(dialect),
    begin: function(cb) {
      if (cb) {
        process.nextTick(cb.bind(null, engine));
      }
      return engine;
    },
    query: function(sql, params, cb) {
      return new EventEmitter;
      if (!cb) {
        return;
      }
      return process.nextTick(cb.bind(null, null, [sql, params]));
    },
    close: function() {}
  };
  return engine;
};
